import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import json_objects.Id;
import json_objects.Message;

import java.io.IOException;
import java.net.URL;
import java.util.List;
import java.util.stream.Stream;

public class YouAreEll {

    ObjectMapper jacksonMapper = new ObjectMapper();

    YouAreEll() {
        Unirest.setObjectMapper(new com.mashape.unirest.http.ObjectMapper() {
            com.fasterxml.jackson.databind.ObjectMapper mapper
                    = new com.fasterxml.jackson.databind.ObjectMapper();

            public String writeValue(Object value) {
                try {
                    return mapper.writeValueAsString(value);
                } catch (JsonProcessingException e) {
                    e.printStackTrace();
                }
                return null;
            }

            public <T> T readValue(String value, Class<T> valueType) {
                try {
                    return mapper.readValue(value, valueType);
                } catch (IOException e) {
                    e.printStackTrace();
                }
                return null;
            }
        });
    }

    public static void main(String[] args) throws IOException, ClassNotFoundException {
        YouAreEll urlhandler = new YouAreEll();
        System.out.println(urlhandler.get_ids());
        System.out.println(urlhandler.get_messages());
    }

    public String get_ids() throws IOException, ClassNotFoundException {
        return makeUrlCall("/ids", "GET", new TypeReference<List<Id>>(){});
    }

    public String get_messages() throws IOException, ClassNotFoundException {
        return makeUrlCall("/messages", "GET", new TypeReference<List<Message>>(){});
    }

    public String get_messages_id(String id) throws IOException, ClassNotFoundException {
        return makeUrlCall(String.format("/" + id + "/messages"), "GET", new TypeReference<List<Id>>(){});
    }

    public String send_id_message(String id, Message message) throws IOException, ClassNotFoundException, UnirestException {
        return makePostCall(
                String.format("/ids/" + id + "/messages"),
                message
        );
    }

    public String urlConcat(String mainurl) {
        return "http://zipcode.rocks:8085" + mainurl;
    }

    public String makeUrlCall(String mainurl, String method, TypeReference javaClass) throws IOException, ClassNotFoundException {
        return makeGetCall(mainurl, javaClass);
    }

    public String makeGetCall(String mainurl, TypeReference javaClass) throws ClassNotFoundException, IOException {
        List<Object> results = jacksonMapper.readValue(new URL(urlConcat(mainurl)), javaClass);
        System.out.println(jacksonMapper.writerWithDefaultPrettyPrinter().writeValueAsString(javaClass));
        return jacksonMapper.writerWithDefaultPrettyPrinter().writeValueAsString(results);
    }

    public String makePostCall(String mainurl, Message messsage) throws ClassNotFoundException, IOException, UnirestException {
        HttpResponse<JsonNode> post = Unirest.post(urlConcat(mainurl))
                .header("accept", "application/json")
                .header("Content-Type", "application/json")
                .body(messsage)
                .asJson();
        return jacksonMapper.writeValueAsString(messsage);
    }

    public <T> Stream<T> makePayloadStream(String mainUrl, TypeReference javaClass) throws IOException {
        List<T> results = jacksonMapper.readValue(new URL(urlConcat(mainUrl)), javaClass);
        return results.stream();
    }



}